searchData={"items":[{"type":"task","title":"mix swagdox.generate","doc":"Generates OpenAPI specification from Elixir function docs.\n\nCommand line options can be used to specify the output title, version, description, servers,\nand router module for the OpenAPI specification. However, if these options are not provided, the\nvalues will attempt to be fetched from the application config.","ref":"Mix.Tasks.Swagdox.Generate.html"},{"type":"task","title":"Usage - mix swagdox.generate","doc":"mix swagdox.generate --output path/to/output.json\n    mix swagdox.generate -o path/to/output.json","ref":"Mix.Tasks.Swagdox.Generate.html#module-usage"},{"type":"task","title":"Options - mix swagdox.generate","doc":"* `--output` - (required) The path to write the output file.\n* `--format` - The format of the output file. Default is `json`.\n* `--title` - The title of the API.\n* `--version` - The version of the API.\n* `--description` - The description of the API.\n* `--servers` - The servers of the API.\n* `--router` - The router module to use.","ref":"Mix.Tasks.Swagdox.Generate.html#module-options"},{"type":"module","title":"Swagdox","doc":"Swagdox is a library for extracting Open API specifications from Elixir function docs.","ref":"Swagdox.html"},{"type":"function","title":"Swagdox.generate_specification/1","doc":"","ref":"Swagdox.html#generate_specification/1"},{"type":"function","title":"Swagdox.write_json/2","doc":"","ref":"Swagdox.html#write_json/2"},{"type":"function","title":"Swagdox.write_yaml/2","doc":"","ref":"Swagdox.html#write_yaml/2"},{"type":"module","title":"Swagdox.Authorization","doc":"Defines a security scheme for an OpenAPI document.","ref":"Swagdox.Authorization.html"},{"type":"function","title":"Swagdox.Authorization.extract/1","doc":"","ref":"Swagdox.Authorization.html#extract/1"},{"type":"function","title":"Swagdox.Authorization.extract_scheme/1","doc":"","ref":"Swagdox.Authorization.html#extract_scheme/1"},{"type":"function","title":"Swagdox.Authorization.init/4","doc":"","ref":"Swagdox.Authorization.html#init/4"},{"type":"function","title":"Swagdox.Authorization.render/1","doc":"","ref":"Swagdox.Authorization.html#render/1"},{"type":"type","title":"Swagdox.Authorization.t/0","doc":"","ref":"Swagdox.Authorization.html#t:t/0"},{"type":"module","title":"Swagdox.Config","doc":"Configuration for the Swagdox library.","ref":"Swagdox.Config.html"},{"type":"function","title":"Swagdox.Config.new/1","doc":"","ref":"Swagdox.Config.html#new/1"},{"type":"type","title":"Swagdox.Config.t/0","doc":"","ref":"Swagdox.Config.html#t:t/0"},{"type":"module","title":"Swagdox.Endpoint","doc":"Describes  a documented endpoint in an application controller.","ref":"Swagdox.Endpoint.html"},{"type":"function","title":"Swagdox.Endpoint.extract_all/1","doc":"Extracts function docs that contain Open API specifications.\nA function doc is considered to contain an Open API specification if it contains\nthe string \"[Swagdox] API:\", followed by one or more lines that start with @-variables.\n\nAn example of a function doc that contains an Open API specification:\n\n    Returns a User.\n\n    [Swagdox] API:\n      @param id, integer, required, \"User ID\"\n\n      @response 200, User, \"User found\"\n      @response 403, \"User not authorized\"\n      @response 404, \"User not found\"","ref":"Swagdox.Endpoint.html#extract_all/1"},{"type":"function","title":"Swagdox.Endpoint.parameters/1","doc":"Returns the parameters for the endpoint.","ref":"Swagdox.Endpoint.html#parameters/1"},{"type":"function","title":"Swagdox.Endpoint.responses/1","doc":"Returns the responses for the endpoint.","ref":"Swagdox.Endpoint.html#responses/1"},{"type":"function","title":"Swagdox.Endpoint.security/1","doc":"Returns the authorization options for the endpoint.","ref":"Swagdox.Endpoint.html#security/1"},{"type":"type","title":"Swagdox.Endpoint.docstring/0","doc":"","ref":"Swagdox.Endpoint.html#t:docstring/0"},{"type":"type","title":"Swagdox.Endpoint.t/0","doc":"","ref":"Swagdox.Endpoint.html#t:t/0"},{"type":"module","title":"Swagdox.Order","doc":"An order placed by a customer\n\n[Swagdox] Schema:\n  @name OrderName\n\n  @property item, string, \"Order item\"\n  @property number, integer, \"Order number\"","ref":"Swagdox.Order.html"},{"type":"module","title":"Swagdox.Parameter","doc":"Describes a parameter in an OpenAPI specification.","ref":"Swagdox.Parameter.html"},{"type":"function","title":"Swagdox.Parameter.build/3","doc":"Creates a new Parameter.\n\nExamples:\n\n      iex> Swagdox.Parameter.build({\"id\", \"query\"}, \"integer\", \"User ID\")\n      %Swagdox.Parameter{\n        name: \"id\",\n        in: \"query\",\n        required: false,\n        description: \"User ID\",\n        schema: %{type: \"integer\"}\n      }\n      iex> Swagdox.Parameter.build({\"id\", \"query\"}, \"integer\", \"User ID\", required: true)\n      %Swagdox.Parameter{\n        name: \"id\",\n        in: \"query\",\n        required: true,\n        description: \"User ID\",\n        schema: %{type: \"integer\"}\n      }","ref":"Swagdox.Parameter.html#build/3"},{"type":"function","title":"Swagdox.Parameter.build/4","doc":"","ref":"Swagdox.Parameter.html#build/4"},{"type":"function","title":"Swagdox.Parameter.render/1","doc":"Renders a Parameter as a map.\n\nExamples:\n\n      iex> Swagdox.Parameter.render(%Swagdox.Parameter{\n      ...>   name: \"id\",\n      ...>   in: \"query\",\n      ...>   required: false,\n      ...>   description: \"User ID\",\n      ...>   schema: %{type: \"integer\"}\n      ...> })\n      %{\n        \"name\" => \"id\",\n        \"in\" => \"query\",\n        \"required\" => false,\n        \"description\" => \"User ID\",\n        \"schema\" => %{\"type\" => \"integer\"}\n      }","ref":"Swagdox.Parameter.html#render/1"},{"type":"function","title":"Swagdox.Parameter.schema/2","doc":"Returns the schema for a Parameter. Raises an ArgumentError if the type is invalid.\n\nExamples:\n\n      iex> Swagdox.Parameter.schema(\"integer\", [])\n      %{type: \"integer\"}\n      iex> Swagdox.Parameter.schema(\"integer\", format: \"int64\")\n      %{type: \"integer\", format: \"int64\"}","ref":"Swagdox.Parameter.html#schema/2"},{"type":"type","title":"Swagdox.Parameter.t/0","doc":"","ref":"Swagdox.Parameter.html#t:t/0"},{"type":"module","title":"Swagdox.Parser","doc":"Parses endpoint docstrings to extract Open API specification data.","ref":"Swagdox.Parser.html"},{"type":"function","title":"Swagdox.Parser.extract_authorizations/1","doc":"","ref":"Swagdox.Parser.html#extract_authorizations/1"},{"type":"function","title":"Swagdox.Parser.extract_description/1","doc":"Extracts the description from a docstring.\n\nExamples:\n\n      iex> extract_description(\"Creates a User.\")\n      \"Creates a User.\"","ref":"Swagdox.Parser.html#extract_description/1"},{"type":"function","title":"Swagdox.Parser.extract_module_doc/1","doc":"Extracts the module docstring from a module.","ref":"Swagdox.Parser.html#extract_module_doc/1"},{"type":"function","title":"Swagdox.Parser.extract_name/1","doc":"","ref":"Swagdox.Parser.html#extract_name/1"},{"type":"function","title":"Swagdox.Parser.extract_params/1","doc":"","ref":"Swagdox.Parser.html#extract_params/1"},{"type":"function","title":"Swagdox.Parser.extract_properties/1","doc":"","ref":"Swagdox.Parser.html#extract_properties/1"},{"type":"function","title":"Swagdox.Parser.extract_responses/1","doc":"","ref":"Swagdox.Parser.html#extract_responses/1"},{"type":"function","title":"Swagdox.Parser.extract_security/1","doc":"","ref":"Swagdox.Parser.html#extract_security/1"},{"type":"function","title":"Swagdox.Parser.parse_definition/1","doc":"Extracts the type of configuration and its value from a line in the Open API specification.\n\nExamples:\n\n      iex> parse_definition(\"@param user(query), map, \"User attributes\"\")\n      {:param, [{\"user\", \"query\"}, \"map\", \"User attributes\"]}","ref":"Swagdox.Parser.html#parse_definition/1"},{"type":"module","title":"Swagdox.Path","doc":"Represents a path in the Open API specification.","ref":"Swagdox.Path.html"},{"type":"function","title":"Swagdox.Path.build/2","doc":"Builds a new Path.\n\nExamples:\n\n  iex> Swagdox.Path.build(endpoint, route)\n  %Swagdox.Path{\n    description: \"Creates a User.\",\n    path: \"/users\",\n    verb: :post\n  }","ref":"Swagdox.Path.html#build/2"},{"type":"function","title":"Swagdox.Path.operation_id/1","doc":"","ref":"Swagdox.Path.html#operation_id/1"},{"type":"type","title":"Swagdox.Path.route/0","doc":"","ref":"Swagdox.Path.html#t:route/0"},{"type":"type","title":"Swagdox.Path.t/0","doc":"","ref":"Swagdox.Path.html#t:t/0"},{"type":"module","title":"Swagdox.PathBuilder","doc":"Builds paths from a router by calling the __routes__ function.\n\nWe can then use the Endpoint.extract_all/1 function to extract the API specification\nfrom the controller modules.","ref":"Swagdox.PathBuilder.html"},{"type":"function","title":"Swagdox.PathBuilder.build_paths/1","doc":"","ref":"Swagdox.PathBuilder.html#build_paths/1"},{"type":"function","title":"Swagdox.PathBuilder.build_router_paths/1","doc":"","ref":"Swagdox.PathBuilder.html#build_router_paths/1"},{"type":"module","title":"Swagdox.Response","doc":"Describes a response in an OpenAPI specification.","ref":"Swagdox.Response.html"},{"type":"function","title":"Swagdox.Response.build/2","doc":"","ref":"Swagdox.Response.html#build/2"},{"type":"function","title":"Swagdox.Response.build/3","doc":"","ref":"Swagdox.Response.html#build/3"},{"type":"function","title":"Swagdox.Response.build/4","doc":"","ref":"Swagdox.Response.html#build/4"},{"type":"function","title":"Swagdox.Response.render/1","doc":"Renders a response to a map.","ref":"Swagdox.Response.html#render/1"},{"type":"function","title":"Examples - Swagdox.Response.render/1","doc":"iex> response = Response.build(200, \"User\", \"OK\")\n    iex> Response.render(response)\n    %{\n      \"200\" => %{\n        \"description\" => \"OK\",\n        \"content\" => %{\n          \"application/json\" => %{\n            \"schema\" => %{\n              \"$ref\" => \"#/components/schemas/User\"\n            }\n          }\n        }\n      }\n    }\n\n    iex> response = Response.build(200, \"OK\")\n    iex> Response.render(response)\n    %{\n      \"200\" => %{\n        \"description\" => \"OK\"\n      }\n    }","ref":"Swagdox.Response.html#render/1-examples"},{"type":"type","title":"Swagdox.Response.t/0","doc":"","ref":"Swagdox.Response.html#t:t/0"},{"type":"module","title":"Swagdox.Schema","doc":"This module provides a way to extract the fields and types of an Ecto.Schema.","ref":"Swagdox.Schema.html"},{"type":"function","title":"Swagdox.Schema.description/1","doc":"","ref":"Swagdox.Schema.html#description/1"},{"type":"function","title":"Swagdox.Schema.infer/1","doc":"","ref":"Swagdox.Schema.html#infer/1"},{"type":"function","title":"Swagdox.Schema.name/1","doc":"","ref":"Swagdox.Schema.html#name/1"},{"type":"function","title":"Swagdox.Schema.properties/1","doc":"","ref":"Swagdox.Schema.html#properties/1"},{"type":"function","title":"Swagdox.Schema.reference/1","doc":"","ref":"Swagdox.Schema.html#reference/1"},{"type":"function","title":"Swagdox.Schema.render/1","doc":"","ref":"Swagdox.Schema.html#render/1"},{"type":"type","title":"Swagdox.Schema.property/0","doc":"","ref":"Swagdox.Schema.html#t:property/0"},{"type":"type","title":"Swagdox.Schema.t/0","doc":"","ref":"Swagdox.Schema.html#t:t/0"},{"type":"module","title":"Swagdox.SchemaBuilder","doc":"Builds a list of all schemas by inspecting the router to\nget a list of the controllers.","ref":"Swagdox.SchemaBuilder.html"},{"type":"function","title":"Swagdox.SchemaBuilder.build_schemas/0","doc":"","ref":"Swagdox.SchemaBuilder.html#build_schemas/0"},{"type":"module","title":"Swagdox.Security","doc":"Defines an authorization option for an endpoint in an OpenAPI\nspecification.","ref":"Swagdox.Security.html"},{"type":"function","title":"Swagdox.Security.build/1","doc":"","ref":"Swagdox.Security.html#build/1"},{"type":"function","title":"Swagdox.Security.build/2","doc":"","ref":"Swagdox.Security.html#build/2"},{"type":"function","title":"Swagdox.Security.render/1","doc":"","ref":"Swagdox.Security.html#render/1"},{"type":"type","title":"Swagdox.Security.t/0","doc":"","ref":"Swagdox.Security.html#t:t/0"},{"type":"module","title":"Swagdox.Spec","doc":"OpenAPI specification.","ref":"Swagdox.Spec.html"},{"type":"function","title":"Swagdox.Spec.generate_paths/1","doc":"Generates the paths for the specification.","ref":"Swagdox.Spec.html#generate_paths/1"},{"type":"function","title":"Swagdox.Spec.generate_schemas/1","doc":"Generates the schemas for the specification.","ref":"Swagdox.Spec.html#generate_schemas/1"},{"type":"function","title":"Swagdox.Spec.generate_security_schemes/1","doc":"Generates security schemes for the specification.","ref":"Swagdox.Spec.html#generate_security_schemes/1"},{"type":"function","title":"Swagdox.Spec.init/1","doc":"Initializes a new OpenAPI specification.","ref":"Swagdox.Spec.html#init/1"},{"type":"function","title":"Swagdox.Spec.render/1","doc":"","ref":"Swagdox.Spec.html#render/1"},{"type":"type","title":"Swagdox.Spec.t/0","doc":"","ref":"Swagdox.Spec.html#t:t/0"},{"type":"module","title":"Swagdox.Type","doc":"Describes a type in an OpenAPI specification.","ref":"Swagdox.Type.html"},{"type":"function","title":"Swagdox.Type.reference/1","doc":"","ref":"Swagdox.Type.html#reference/1"},{"type":"function","title":"Swagdox.Type.render/1","doc":"","ref":"Swagdox.Type.html#render/1"},{"type":"type","title":"Swagdox.Type.variable/0","doc":"","ref":"Swagdox.Type.html#t:variable/0"},{"type":"module","title":"Swagdox.User","doc":"A user of the application\n\n[Swagdox] Schema:\n  @name User\n\n  @property id, integer, \"User id\"\n  @property name, string, \"User name\"\n  @property email, string, \"User email\"\n  @property orders, [OrderName], \"User orders\"","ref":"Swagdox.User.html"},{"type":"module","title":"SwagdoxWeb.DefaultConfig","doc":"","ref":"SwagdoxWeb.DefaultConfig.html"},{"type":"function","title":"SwagdoxWeb.DefaultConfig.config/0","doc":"","ref":"SwagdoxWeb.DefaultConfig.html#config/0"},{"type":"module","title":"SwagdoxWeb.OrderController","doc":"","ref":"SwagdoxWeb.OrderController.html"},{"type":"function","title":"SwagdoxWeb.OrderController.create/2","doc":"Creates an Order.\n\n[Swagdox] API:\n  @param order(body), object, \"Order attributes\", required: true\n\n  @response 201, OrderName, \"Order created\"\n  @response 400, \"Invalid order attributes\"\n\n  @security ApiKey, [write]","ref":"SwagdoxWeb.OrderController.html#create/2"},{"type":"function","title":"SwagdoxWeb.OrderController.delete/2","doc":"Deletes an Order.\n\n[Swagdox] API:\n  @param id(path), integer, \"Order ID\", required: true\n\n  @response 204, \"Order deleted\"\n  @response 403, \"Order not authorized\"\n  @response 404, \"Order not found\"\n\n  @security ApiKey, [write]","ref":"SwagdoxWeb.OrderController.html#delete/2"},{"type":"function","title":"SwagdoxWeb.OrderController.index/2","doc":"Returns a list of Orders\n\n[Swagdox] API:\n  @response 200, [OrderName], \"Orders found\"\n  @response 403, \"Orders not authorized\"\n\n  @security ApiKey, [read]","ref":"SwagdoxWeb.OrderController.html#index/2"},{"type":"function","title":"SwagdoxWeb.OrderController.show/2","doc":"Returns an Order.\n\n[Swagdox] API:\n  @param id(path), integer, \"Order ID\", required: true\n\n  @response 200, OrderName, \"Order found\"\n  @response 403, \"Order not authorized\"\n  @response 404, \"Order not found\"\n\n  @security ApiKey, [read]","ref":"SwagdoxWeb.OrderController.html#show/2"},{"type":"module","title":"SwagdoxWeb.Router","doc":"Routes for our SwagdoxWeb application.\n\n[Swagdox] Router:\n  @authorization BasicAuth, basic, \"Basic http authentication\"\n  @authorization ApiKey, header(\"X-API-Key\"), \"API key authentication\"","ref":"SwagdoxWeb.Router.html"},{"type":"type","title":"SwagdoxWeb.Router.route/0","doc":"","ref":"SwagdoxWeb.Router.html#t:route/0"},{"type":"module","title":"SwagdoxWeb.UserController","doc":"","ref":"SwagdoxWeb.UserController.html"},{"type":"function","title":"SwagdoxWeb.UserController.create/2","doc":"Creates a User.\n\n[Swagdox] API:\n  @param user(body), object, \"User attributes\", required: true\n\n  @response 201, User, \"User created\"\n  @response 400, \"Invalid user attributes\"\n\n  @security BasicAuth, [admin]","ref":"SwagdoxWeb.UserController.html#create/2"},{"type":"function","title":"SwagdoxWeb.UserController.delete/2","doc":"","ref":"SwagdoxWeb.UserController.html#delete/2"},{"type":"function","title":"SwagdoxWeb.UserController.index/2","doc":"Returns a list of Users","ref":"SwagdoxWeb.UserController.html#index/2"},{"type":"function","title":"SwagdoxWeb.UserController.show/2","doc":"Returns a User.\n\n[Swagdox] API:\n  @param id(path), integer, \"User ID\", required: true\n\n  @response 200, User, \"User found\"\n  @response 403, \"User not authorized\"\n  @response 404, \"User not found\"\n\n  @security BasicAuth, [read]","ref":"SwagdoxWeb.UserController.html#show/2"},{"type":"exception","title":"Swagdox.Parser.ParserError","doc":"","ref":"Swagdox.Parser.ParserError.html"},{"type":"extras","title":"Overview","doc":"# Overview\n\n![CI Pipeline](https://github.com/dylanblakemore/swagdox/actions/workflows/elixir.yml/badge.svg)\n[![Hex.pm](https://img.shields.io/hexpm/v/swagdox.svg)](https://hex.pm/packages/swagdox)\n[![Documentation](https://img.shields.io/badge/documentation-gray)](https://hexdocs.pm/swagdox/api-reference.html)\n\nSwagdox is a Swagger/OpenAPI specification generator inspired by [Swaggeryard](https://github.com/livingsocial/swagger_yard).\n\nWhile multiple OpenAPI libraries exist for Elixir, they all feel intrusive in some way or another. The goal of Swagdox is to\nmake the API specifications unobtrusive and simple. This is achieved by having the API be specified in the function docs,\nusing a similar syntax to Swaggeryard. The primary motivator for this is that our eyes tend to gloss over comments and documentation\nunless we are actively trying to read it, and the code doesn't feel cluttered. We even have a precedent for this behaviour in ExDocs!","ref":"readme.html"},{"type":"extras","title":"Generating - Overview","doc":"The specification file can be generated in yaml or json format using the `swagdox.generate` mix task. The command line options are as follows:\n\n- `--output` - (required) The path to write the output file.\n- `--format` - The format of the output file. Default is `json`.\n- `--title` - The title of the API.\n- `--version` - The version of the API.\n- `--description` - The description of the API.\n- `--servers` - The servers of the API.\n- `--router` - The router module to use.\n\nAll options can alternatively be specified using standard shorthand syntax (`-o`, `-f` etc.)","ref":"readme.html#generating"},{"type":"extras","title":"Configuration - Overview","doc":"Swagdox configuration can be set in the project setup in `mix.exs`, using the following configuration options:\n\n```elixir\ndef project do\n  [\n    swagdox: [\n      router: MyAppWeb.Router,\n      format: \"yaml\",\n      output: \"./openapi.yml\",\n      title: \"My App\",\n      version: \"1.0\",\n      description: \"A longer description\"\n    ]\n  ]\nend\n```\n\nAlternatively, any and all of these options can be set via command line arguments:\n\n```bash\nmix swagdox.generate -o ./openapi.yml -f yaml -v 1.0 -t \"My App\" -d \"A longer description\" -s \"localhost://4001,my-app.my-domain.com\" -r MyAppWeb.Router\n```","ref":"readme.html#configuration"},{"type":"extras","title":"Specification - Overview","doc":"#","ref":"readme.html#specification"},{"type":"extras","title":"Router - Overview","doc":"Authorization schemes are described in the moduledoc of the top-level router for the project as follows:\n\n```elixir\ndefmodule MyAppWeb.Router do\n  @moduledoc \"\"\"\n  The router for my app.\n\n  [Swagdox] Router:\n    @authorization ApiAuth, header(\"X-API-Key\"), \"Header-based API authorization\"\n    @authorization BearerAuth, bearer, \"Bearer auth\"\n  \"\"\"\nend\n```\n\nThe format of the specification is `@authorization Name, type(opts), \"Description\"`. The name can be anything - it is used later as a reference\nin paths. The currently supported types are:\n\n- `header, cookie, body, query`: used for API authentication. Requires an opt which describes the key of the token\n- `basic, bearer`: describe basic http authentication\n\n#","ref":"readme.html#router"},{"type":"extras","title":"API - Overview","doc":"Specifying the API for a controller endpoint is similar to specifying examples for ExDoc:\n\n```elixir\ndefmodule MyApp.UserController do\n\n  @doc \"\"\"\n  Returns a User.\n\n  [Swagdox] API:\n    @param id(query), integer, \"User ID\", required: true\n\n    @response 200, User, \"User found\"\n    @response 403, \"User not authorized\"\n    @response 404, \"User not found\"\n\n    @security ApiAuth, [read]\n  \"\"\"\n  @spec show(any(), map()) :: nil\n  def show(_conn, _params) do\n    ...\n  end\nend\n```\n\nThe above example shows how we can describe parameters and responses. The `[Swagdox] API:` tag is what signals\na specification. The security tag should be a name of a registered authorization scheme.\n\n##","ref":"readme.html#api"},{"type":"extras","title":"Parameters - Overview","doc":"Parameter specifications must follow the format:\n\n```elixir\n@param name(in), type, description, kwargs\n```\n\nwhere `kwargs` is a keyword-list of additional arguments used by OpenAPI specs.\n\n##","ref":"readme.html#parameters"},{"type":"extras","title":"Responses - Overview","doc":"Response are described similarly, and must follow one of these formats:\n\n```elixir\n@response code, type, description\n\n@response code, description\n```\n\n##","ref":"readme.html#responses"},{"type":"extras","title":"Types - Overview","doc":"For both parameters and responses, the type of the variable can be defined either as a\nstandard type or as a schema. Basic types include:\n\n- `integer`\n- `number`\n- `string`\n- `boolean`\n- `array`\n- `object`\n\nSchemas (described below) are well-defined objects, identified by the fact that they always start with an upper-case letter.\nArrays of types can be specified using the `[]` notation:\n\n```elixir\n@response 200, [User], ...\n```\n\n#","ref":"readme.html#types"},{"type":"extras","title":"Schemas - Overview","doc":"Swagdox schemas can be defined by adding a schema definition to the moduledocs.\nThe definition must include a name, and can include one or more properties which\nshould have the name, type, and optional description.\n\n```elixir\ndefmodule Swagdox.Order do\n  @mouledoc \"\"\"\n  Some description\n\n  [Swagdox] Schema:\n    @name Order\n    @property item, string, \"The item name\"\n    @property number, integer, \"The number of items ordered\"\n  \"\"\"\nend\n```\n\nSchemas are detected automatically based on the `[Swagdox] Schema:` tag.","ref":"readme.html#schemas"},{"type":"extras","title":"Installation - Overview","doc":"Add `swagdox` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:swagdox, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\n## [0.1.0] - 26 May 2024\n\n#","ref":"changelog.html"},{"type":"extras","title":"First release - Changelog","doc":"- Generate OpenAPI specification using `swagdox.generate` task\n- Add authentication in Router moduledoc\n- Describe models in moduledocs of schemas\n  - Models are automatically detected by presence of `[Swagdox] Schema:` tag\n- Describe endpoints using function docs\n  - Controllers are detected by defining the router module\n  - Endpoints are detected within the controller by the presence of `[Swagdox] API:` tag\n\n## [0.1.1] - 21 June 2024\n\n#","ref":"changelog.html#first-release"},{"type":"extras","title":"Documentation improvements - Changelog","doc":"- Add ReadMe, Changelog, and License to docs\n- Redirect docs to Readme\n\n## [0.1.2] - 21 June 2024\n\n#","ref":"changelog.html#documentation-improvements"},{"type":"extras","title":"Documentation fix - Changelog","doc":"- Fix reference to readme html","ref":"changelog.html#documentation-fix"},{"type":"extras","title":"License","doc":"# License\n\nCopyright 2024 Dylan Blakemore\n\nPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the “Software”), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}